package it.dsestili.jhash.gui;

/*
JHash a simple hash code generator
Copyright (C) 2013 Davide Sestili

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.FlowLayout;
import java.awt.Frame;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Font;
import java.awt.Insets;
import java.net.URI;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

@SuppressWarnings("serial")
public class AboutDialog extends JDialog {

	private final JPanel contentPanel = new JPanel();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			new AboutDialog(null);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public AboutDialog(Frame owner) 
	{
		super(owner);
		setTitle("About");
		setFont(new Font("Tahoma", Font.PLAIN, 18));
		
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		GridBagLayout gbl_contentPanel = new GridBagLayout();
		gbl_contentPanel.columnWidths = new int[]{0, 0};
		gbl_contentPanel.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0};
		gbl_contentPanel.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_contentPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		contentPanel.setLayout(gbl_contentPanel);
		{
			JLabel lblInfo = new JLabel("<html>\r\n<b>JHash</b>\r\n<br>\r\na simple hash code generator\r\n<br>\r\nCopyright (C) 2013 Davide Sestili\r\n</html>");
			lblInfo.setFont(new Font("Tahoma", Font.PLAIN, 18));
			GridBagConstraints gbc_lblInfo = new GridBagConstraints();
			gbc_lblInfo.anchor = GridBagConstraints.WEST;
			gbc_lblInfo.insets = new Insets(0, 0, 5, 0);
			gbc_lblInfo.gridx = 0;
			gbc_lblInfo.gridy = 0;
			contentPanel.add(lblInfo, gbc_lblInfo);
		}
		{
			JLabel lblMail = new JLabel("<HTML><FONT color=\"#000099\"><U>davide.sestili@gmail.com</U></FONT></HTML>");
			lblMail.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
			lblMail.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) 
				{
					try 
					{
						if(Desktop.isDesktopSupported())
						{
							Desktop desktop = Desktop.getDesktop();
							desktop.mail(new URI("mailto:davide.sestili@gmail.com"));
						}
					} 
					catch(Throwable t) 
					{
						t.printStackTrace();
					}
				}
			});
			lblMail.setFont(new Font("Tahoma", Font.PLAIN, 18));
			GridBagConstraints gbc_lblMail = new GridBagConstraints();
			gbc_lblMail.insets = new Insets(0, 0, 5, 0);
			gbc_lblMail.anchor = GridBagConstraints.WEST;
			gbc_lblMail.gridx = 0;
			gbc_lblMail.gridy = 1;
			contentPanel.add(lblMail, gbc_lblMail);
		}
		{
			JLabel lblLicense = new JLabel("License: GNU General Public License v3");
			lblLicense.setFont(new Font("Tahoma", Font.PLAIN, 18));
			GridBagConstraints gbc_lblLicense = new GridBagConstraints();
			gbc_lblLicense.insets = new Insets(0, 0, 5, 0);
			gbc_lblLicense.anchor = GridBagConstraints.WEST;
			gbc_lblLicense.gridx = 0;
			gbc_lblLicense.gridy = 2;
			contentPanel.add(lblLicense, gbc_lblLicense);
		}
		JLabel lblURL = new JLabel("<HTML><FONT color=\"#000099\"><U>http://www.gnu.org/licenses/gpl.html</U></FONT></HTML>");
		lblURL.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		lblURL.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) 
			{
				try 
				{
					if(Desktop.isDesktopSupported())
					{
						Desktop desktop = Desktop.getDesktop();
						desktop.browse(new URI("http://www.gnu.org/licenses/gpl.html"));
					}
				} 
				catch(Throwable t) 
				{
					t.printStackTrace();
				}
			}
		});
		lblURL.setFont(new Font("Tahoma", Font.PLAIN, 18));
		GridBagConstraints gbc_lblURL = new GridBagConstraints();
		gbc_lblURL.insets = new Insets(0, 0, 5, 0);
		gbc_lblURL.anchor = GridBagConstraints.WEST;
		gbc_lblURL.gridx = 0;
		gbc_lblURL.gridy = 3;
		contentPanel.add(lblURL, gbc_lblURL);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) 
					{
						dispose();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
		}
		
		setVisible(true);
	}

}
